using XLSX
using Statistics
using DataFrames

#DATA IDENTIFICATION
instance = 1 #ONLY VALUE TO UPDATE every time (with numbers from 1 tà 24)
File = "DATA"
Situation2 = "A2" #number of requests, always at the same place
Situation3 = "B2" #number of active requests, always at the same place
Situation4 = "A4" #number of drivers, always at the same place
Situation6 = "B4" #speed, always at the same place
Situation7 = "C4" #max route duration, always at the same place

if instance == 1
    customers = 5
    t = 0
    f = 0
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A7:T16" #requests
    global Situation5 = "D5:F6" #capacity of vehicles for each resource type
elseif instance == 2
    customers = 5
    t = 1
    f = 1
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A7:T18" #requests
    global Situation5 = "D5:F6" #capacity of vehicles for each resource type
elseif instance == 3
    customers = 10
    t = 0
    f = 2
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A11:T30" #requests
    global Situation5 = "D5:F10" #capacity of vehicles for each resource type
elseif instance == 4
    customers = 10
    t = 1
    f = 0
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A9:T32" #requests
    global Situation5 = "D5:F8" #capacity of vehicles for each resource type
elseif instance == 5
    customers = 15
    t = 0
    f = 0
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A11:T40" #requests
    global Situation5 = "D5:F10" #capacity of vehicles for each resource type
elseif instance == 6
    customers = 15
    t = 1
    f = 1
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A13:T44" #requests
    global Situation5 = "D5:F12" #capacity of vehicles for each resource type
elseif instance == 7
    customers = 20
    t = 0
    f = 2
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A17:T56" #requests
    global Situation5 = "D5:F16" #capacity of vehicles for each resource type
elseif instance == 8
    customers = 20
    t = 1
    f = 1
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A15:T64" #requests
    global Situation5 = "D5:F14" #capacity of vehicles for each resource type
elseif instance == 9
    customers = 25
    t = 0
    f = 0
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A15:T64" #requests
    global Situation5 = "D5:F14" #capacity of vehicles for each resource type
elseif instance == 10
    customers = 25
    t = 1
    f = 1
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A19:T74" #requests
    global Situation5 = "D5:F18" #capacity of vehicles for each resource type
elseif instance == 11
    customers = 30
    t = 0
    f = 2
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A24:T83" #requests
    global Situation5 = "D5:F23" #capacity of vehicles for each resource type
elseif instance == 12
    customers = 30
    t = 1
    f = 0
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A19:T90" #requests
    global Situation5 = "D5:F18" #capacity of vehicles for each resource type
elseif instance == 13
    customers = 35
    t = 0
    f = 1
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A21:T90" #requests
    global Situation5 = "D5:F20" #capacity of vehicles for each resource type
elseif instance == 14
    customers = 35
    t = 1
    f = 2
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A29:T108" #requests
    global Situation5 = "D5:F28" #capacity of vehicles for each resource type
elseif instance == 15
    customers = 40
    t = 0
    f = 2
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A28:T107" #requests
    global Situation5 = "D5:F27" #capacity of vehicles for each resource type
elseif instance == 16
    customers = 40
    t = 1
    f = 1
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A24:T119" #requests
    global Situation5 = "D5:F23" #capacity of vehicles for each resource type
elseif instance == 17
    customers = 45
    t = 0
    f = 0
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A17:T106" #requests
    global Situation5 = "D5:F16" #capacity of vehicles for each resource type
elseif instance == 18
    customers = 45
    t = 1
    f = 2
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A32:T135" #requests
    global Situation5 = "D5:F31" #capacity of vehicles for each resource type
elseif instance == 19
    customers = 50
    t = 0
    f = 1
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A27:T126" #requests
    global Situation5 = "D5:F26" #capacity of vehicles for each resource type
elseif instance == 20
    customers = 50
    t = 1
    f = 0
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A21:T142" #requests
    global Situation5 = "D5:F20" #capacity of vehicles for each resource type
elseif instance == 21
    customers = 75
    t = 0
    f = 0
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A26:T175" #requests
    global Situation5 = "D5:F25" #capacity of vehicles for each resource type
elseif instance == 22
    customers = 75
    t = 1
    f = 2
    h = 1
    c = 1
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A49:T228" #requests
    global Situation5 = "D5:F48" #capacity of vehicles for each resource type
elseif instance == 23
    customers = 100
    t = 0
    f = 2
    h = 1
    c = 2
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A89:T288" #requests
    global Situation5 = "D5:F88" #capacity of vehicles for each resource type
elseif instance == 24
    customers = 100
    t = 1
    f = 1
    h = 1
    c = 0
    global instance_name = "$instance - dcdarp_$customers.t$t.f$f.h$h.c$c"
    global Situation1 = "A70:T321" #requests
    global Situation5 = "D5:F69" #capacity of vehicles for each resource type
end

#DATA IMPORTATION IN JULIA
Matrix_requests=XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation1")
Nb_of_requests=XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation2")
Nb_of_active_requests=XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation3")
Nb_drivers=XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation4")
Cap_vehicles=XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation5")
cap_vehicles = Cap_vehicles
Nb_cust = size(unique(Matrix_requests[:,2]))[1]
speed = XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation6")
max_route_duration = XLSX.readdata("data/$File.xlsx", "$instance_name", "$Situation7")


#STRUCTURES CREATION for single routes, daily routes for all drivers, weekly routes for all drivers
mutable struct Vec_Loc
    ID_stop::Number
    ID_loc::Number
    ID_cust::Number
    earliest_a::Number
    effective_a::Number
    latest_a::Number
    start_service::Number
    service_time::Number
    earliest_d::Number
    effective_d::Number
    latest_d::Number
    current_slack_time::Number
    load_A::Number
    load_B::Number
    load_C::Number
    ID_request::Number
    P_or_D::Number #1 for pickups, 2 for deliveries
end

mutable struct Route
    localisations::Vector{Vec_Loc}
end

mutable struct Daily_Sol
    routes::Vector{Route}
end

mutable struct Weekly_Sol
    solutions::Vector{Daily_Sol}
end

#STUCTURES CREATION for requests and daily lists of requests
mutable struct Request
    ID_request::Number
    ID_cust::Number
    ID_loc_P::Number
    service_time::Number
    TW_A_P::Number
    TW_B_P::Number
    ID_loc_D::Number
    TW_A_D::Number
    TW_B_D::Number
    load_A::Number
    load_B::Number
    load_C::Number
    max_ride_time::Number
end

mutable struct DailyRequests
    daily_requests::Vector{Request}
end

mutable struct WeeklyRequests
    weekly_requests::Vector{DailyRequests}
end

#FUNCTIONS USED IN THE ALGORITHM
#----------------------------TRAVEL TIMES COMPUTATION BETWEEN LOCATIONS -------------------------#
function times_computation(vec_x,vec_y,speed)
    dim=size(vec_x)[1]
    distances_matrix = zeros(dim, dim)
    for i = 1:dim
        for j = i:dim
        distance = sqrt((vec_y[j]-vec_y[i])^2 + (vec_x[j]-vec_x[i])^2)
        distances_matrix[i,j] = distance
        distances_matrix[j,i] = distance
        end
    end
    times_matrix = zeros(dim,dim)
        for i in 1:dim
            for j in i:dim
                time = distances_matrix[i,j]/speed*60
                times_matrix[i,j] = time
                times_matrix[j,i] = time
            end
        end
    return times_matrix
end

#----------------------LOCALISATIONS' NUMBERS ALLOCATION-----------------------#
function loc_to_num(vec_x, vec_y, Matrix_requests)
num = 0.00
dim = size(vec_x)[1]
num_loc_associations = zeros(dim,3)
    for i in 1:dim
        num_loc_associations[i,1] = num
        num_loc_associations[i,2] = vec_x[i]
        num_loc_associations[i,3] = vec_y[i]
        num=num+1
    end
    return num_loc_associations
end

function loc_to_num_inmatrix(vec_x, vec_y, num_loc_associations,Matrix_requests)
dim = size(vec_x)[1]
dim2 = dim-1
New_Matrix_requests = zeros(dim2,18)
    for i in 1:dim2
        for j in 1:dim
        if(Matrix_requests[i,3] == vec_x[j] && Matrix_requests[i,4] == vec_y[j])
            New_Matrix_requests[i,3] = num_loc_associations[j,1]
        elseif(Matrix_requests[i,8] == vec_x[j] && Matrix_requests[i,9] == vec_y[j])
            New_Matrix_requests[i,7] = num_loc_associations[j,1]
            end
        end
    end
    for i in 1:dim2
        for j in 1:2
            New_Matrix_requests[i,j] = Matrix_requests[i,j]
        end
    end
    for i in 1:dim2
        for j in 4:6
            New_Matrix_requests[i,j] = Matrix_requests[i,j+1]
        end
    end
    for i in 1:dim2
        for j in 8:18
            New_Matrix_requests[i,j] = Matrix_requests[i,j+2]
        end
    end
    return New_Matrix_requests
end

#-------------------------------DAILY REQUESTS EXTRACT FROM XLSX FILES-------------------------#
function daily_requests(day,Matrix_requests)
    r = 0
    dim = size(Matrix_requests)[1]
    for i in 1:dim
        if Matrix_requests[i,13+day] == 1
            r=r+1
        end
    end
    daily_requests_matrix = zeros((r,18))
    k = 1
        for i in 1:dim
            if Matrix_requests[i,13+day] == 1
                    daily_requests_matrix[k,:] = Matrix_requests[i,:]
                k = k+1
            end
        end
    return daily_requests_matrix
end

#--------------------------EXTRACT OF REQUESTS FROM MATRIX (XLSX) AND CREATION OF DAILY STRUCTURE OF REQUESTS----------------------------------#
function requests_list(daily_requests_matrix)
nb_requests = size(daily_requests_matrix)[1]
daily_requests = []
    for i in 1:nb_requests
        request = Request(trunc(Int,daily_requests_matrix[i,1]),trunc(Int,daily_requests_matrix[i,2]),trunc(Int,daily_requests_matrix[i,3]),trunc(Int,daily_requests_matrix[i,4]),trunc(Int,daily_requests_matrix[i,5]),trunc(Int,daily_requests_matrix[i,6]),trunc(Int,daily_requests_matrix[i,7]),trunc(Int,daily_requests_matrix[i,9]),trunc(Int,daily_requests_matrix[i,10]),trunc(Int,daily_requests_matrix[i,11]),trunc(Int,daily_requests_matrix[i,12]),trunc(Int,daily_requests_matrix[i,13]),0)
        max_ride_time = max(20,2*times_matrix[request.ID_loc_P+1,request.ID_loc_D+1])
        request.max_ride_time = max_ride_time
        insert!(daily_requests,i,request)
    end
daily_requests_list = DailyRequests(daily_requests)
    return daily_requests_list
end


#---------------------------------------INITIALIZATION OF A ROUTE (DEPOT AND  FIRST CUSTOMER ACCEPTED)-------------------------------------------#
function initialization_road(route::Route, request1::Request,times_matrix)
    test = false
    init_depot = Vec_Loc(1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0) #depot placement
    loc1 = Vec_Loc(2,request1.ID_loc_P,request1.ID_cust,0,0,0,0,request1.service_time,0,0,0,0,request1.load_A,request1.load_B,request1.load_C,request1.ID_request,1) #first loc initialization (PICK UP)
    loc2 = Vec_Loc(3,request1.ID_loc_D,request1.ID_cust,0,0,0,0,request1.service_time,0,0,0,0,0,0,0,request1.ID_request,2) #second loc initlization (DELIVERY)
    final_depot = Vec_Loc(4,0,0,0,0,720,0,0,0,0,0,0,0,0,0,0,0) #final depot placement

    route_test = [init_depot, loc1, loc2, final_depot]
    route_test = Route(route_test)
    nb_loc = size(route_test.localisations)[1]

    for i in 2:nb_loc #earliest arrival/departure times computation
        route_test.localisations[i].earliest_a = route_test.localisations[i-1].earliest_d + times_matrix[route_test.localisations[i-1].ID_loc+1,route_test.localisations[i].ID_loc+1]

        if i == 2
            global TWA = request1.TW_A_P
        elseif i == 3
            global TWA = request1.TW_A_D
        elseif i == nb_loc
            global TWA = 0
        end

        if i != nb_loc
        route_test.localisations[i].earliest_d = max(TWA,route_test.localisations[i].earliest_a) + request1.service_time
        end
    end

    for i in nb_loc-1:-1:1 #latest arrival/departure times computation
        route_test.localisations[i].latest_d = route_test.localisations[i+1].latest_a - times_matrix[route_test.localisations[i+1].ID_loc+1,route_test.localisations[i].ID_loc+1]

        if i == 3
            global TWB = request1.TW_B_D
        elseif i == 2
            global TWB = request1.TW_B_P
        elseif i == 1
            global TWB = 720
        end

        if i != 1
            route_test.localisations[i].latest_a = min(route_test.localisations[i].latest_d - request1.service_time,TWB)
        end
    end

    for i in 1:nb_loc #effective arrival/departure times decisions
        if i == 1
            route_test.localisations[i].effective_d = route_test.localisations[i].latest_d
        elseif i != 1 && i != nb_loc
            if i == 2
                global TWA = request1.TW_A_P
            elseif i == 3
                global TWA = request1.TW_A_D
            end
            route_test.localisations[i].effective_a = route_test.localisations[i-1].effective_d + times_matrix[route_test.localisations[i-1].ID_loc+1,route_test.localisations[i].ID_loc+1]
            route_test.localisations[i].start_service = max(route_test.localisations[i].effective_a,TWA)
            route_test.localisations[i].effective_d = route_test.localisations[i].start_service+ request1.service_time
        elseif i == nb_loc
            route_test.localisations[i].effective_a = route_test.localisations[i-1].effective_d + times_matrix[route_test.localisations[i-1].ID_loc+1,route_test.localisations[i].ID_loc+1]
        end
    end

    for i in 1:nb_loc
        route_test.localisations[i].current_slack_time = route_test.localisations[i].latest_d - route_test.localisations[i].earliest_d
        if i == nb_loc
            route_test.localisations[i].current_slack_time = route_test.localisations[i].latest_a - route_test.localisations[i].earliest_a
        end

    end

    #feasibility checks

    if route_test.localisations[1].effective_d >= 0
        if route_test.localisations[nb_loc].effective_a <= 720
            if route_test.localisations[nb_loc].effective_a - route_test.localisations[1].effective_d <= 480
                if all(route_test.localisations[i].effective_a >= route_test.localisations[i].earliest_a && route_test.localisations[i].effective_a <= route_test.localisations[i].latest_a for i in 1:nb_loc)
                    if all(route_test.localisations[i].effective_d >= route_test.localisations[i].earliest_d && route_test.localisations[i].effective_d <= route_test.localisations[i].latest_d for i in 1:nb_loc)
                        if route_test.localisations[3].effective_a - (route_test.localisations[2].effective_d) <= request1.max_ride_time
                            test = true
                            route = route_test
                            return (route,test)
                        else
                            return (route,test)
                        end
                    else
                        return (route,test)
                    end
                else
                    return (route,test)
                end
            else
                return (route,test)
            end
         else
            return (route,test)
        end
    else
        return (route,test)
    end
end

#---------------------FIND WHERE IS THE BEST POSSIBILITY TO INSERT A PICKUP IN A ROAD TO MINIMIZE THE TOTAL ROUTE DURATION TO THE BEST EXTENT -------------------------------------#
function find_allindex_P(current_road::Route,request::Request,times_matrix)
current_nb_loc = size(current_road.localisations)[1]
#memory of all the possibilities in a vector
vec_index = []
for i in 2:current_nb_loc #find where it's possible to insert the pickup
    shift = times_matrix[current_road.localisations[i-1].ID_loc+1,request.ID_loc_P+1] + request.service_time + times_matrix[request.ID_loc_P+1,current_road.localisations[i].ID_loc+1]
    if all(current_road.localisations[j].current_slack_time >= shift for j in i:current_nb_loc)
        push!(vec_index,i)
    end
end

max_index = 0
#verifying that the driver have the customer for the outbound travel
for i in 2:current_nb_loc
    if current_road.localisations[i].ID_cust == request.ID_cust && current_road.localisations[i].ID_loc == request.ID_loc_D
        for j in i:current_nb_loc
            if current_road.localisations[j].ID_cust == request.ID_cust && current_road.localisations[j].ID_loc == request.ID_loc_P
                max_index = j
            end
        end
    end
end

#if the driver already has the outbound travel of the customer, the pickup of the indboud travel cannot be placed before the delivery of the outboun travel
if max_index != 0
    for i in size(vec_index)[1]:-1:1
        if vec_index[i] <= max_index
            deleteat!(vec_index,i)
        end
    end
end
    return vec_index
end

#-----------------------FIND WHERE IS THE BEST POSSIBILITY TO INSERT A DELIVERY  IN A ROAD IN ORDER TO MINIMIZE THE TOTAL ROUTE DURATION TO THE BEST EXTENT---------------------------------#
function find_allindex_D(current_road::Route,request::Request,times_matrix,indexP)
current_nb_loc = size(current_road.localisations)[1]
#memory of all the possibilities in a vector
vec_index = []
for i in indexP+1:current_nb_loc #find where it's possible to insert the delivery
    shift = times_matrix[current_road.localisations[i-1].ID_loc+1,request.ID_loc_D+1] + request.service_time + times_matrix[request.ID_loc_D+1,current_road.localisations[i].ID_loc+1]
    if all(current_road.localisations[j].current_slack_time >= shift for j in i:current_nb_loc)
        push!(vec_index,i)
    end
end
    return vec_index
end

#------------------------------------------ INSERTION TEST OF A REQUEST IN A ROAD--------------------------------------------------------------------#
function insert_request_P(current_road::Route,request::Request,indexP,daily_requests::DailyRequests,times_matrix,cap_vehicles_vector,max_route_duration)
    test = false
    current_road_test::Route = deepcopy(current_road)  #creation of a copy, if all the tests are ok, current_road will be replaced by current_road_test
    current_nb_loc = size(current_road_test.localisations)[1]

    index = indexP

    new_load_A = current_road.localisations[index-1].load_A+request.load_A
    new_load_B = current_road.localisations[index-1].load_B+request.load_B
    new_load_C = current_road.localisations[index-1].load_C+request.load_C
    e_arr = current_road_test.localisations[index-1].earliest_d + times_matrix[current_road_test.localisations[index-1].ID_loc+1,request.ID_loc_P+1]
    TWA = request.TW_A_P
    e_dep = max(TWA, e_arr) + request.service_time
    eff_a = current_road_test.localisations[index-1].effective_d + times_matrix[current_road_test.localisations[index-1].ID_loc+1,request.ID_loc_P+1]
    eff_d = eff_a + request.service_time
    start_service = max(eff_a,TWA) + request.service_time
    new_loc = Vec_Loc(index,request.ID_loc_P,request.ID_cust,e_arr,eff_a,0,start_service,request.service_time,e_dep,eff_d,0,0,new_load_A,new_load_B,new_load_C,request.ID_request,1)
    insert!(current_road_test.localisations,index,new_loc) #insertion of the pickup localisation in the testing road
    new_nb_loc = size(current_road_test.localisations)[1]

    #UPDATE OF THE END OF THE ROUTE
    for i in index+1:new_nb_loc-1 #update of the end of the route
        current_road_test.localisations[i].ID_stop = i
        for j in 1:size(daily_requests.daily_requests)[1]
            if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                current_road_test.localisations[i].load_A = current_road_test.localisations[i-1].load_A + daily_requests.daily_requests[j].load_A
                current_road_test.localisations[i].load_B = current_road_test.localisations[i-1].load_B + daily_requests.daily_requests[j].load_B
                current_road_test.localisations[i].load_C = current_road_test.localisations[i-1].load_C + daily_requests.daily_requests[j].load_C
            elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                current_road_test.localisations[i].load_A = current_road_test.localisations[i-1].load_A - daily_requests.daily_requests[j].load_A
                current_road_test.localisations[i].load_B = current_road_test.localisations[i-1].load_B - daily_requests.daily_requests[j].load_B
                current_road_test.localisations[i].load_C = current_road_test.localisations[i-1].load_C - daily_requests.daily_requests[j].load_C
            end
        end
    end

    current_road_test.localisations[new_nb_loc].ID_stop = new_nb_loc

    for i in 2:new_nb_loc
        current_road_test.localisations[i].earliest_a = current_road_test.localisations[i-1].earliest_d + times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
        for j in 1:size(daily_requests.daily_requests)[1]
            if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                global TWA = daily_requests.daily_requests[j].TW_A_P
            elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                global TWA = daily_requests.daily_requests[j].TW_A_D
            end
        if i != new_nb_loc
            current_road_test.localisations[i].earliest_d = max(TWA,current_road_test.localisations[i].earliest_a) + current_road_test.localisations[i].service_time
        end
    end
end

    for i in new_nb_loc-1:-1:1 #recomputation of latest arrival/departure times & slack times
        current_road_test.localisations[i].latest_d = current_road_test.localisations[i+1].latest_a - times_matrix[current_road_test.localisations[i+1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
        for j in 1:size(daily_requests.daily_requests)[1]
            if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                global TWB = daily_requests.daily_requests[j].TW_B_P
            elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                global TWB = daily_requests.daily_requests[j].TW_B_D
            end
        current_road_test.localisations[i].latest_a = min(current_road_test.localisations[i].latest_d- current_road_test.localisations[i].service_time,TWB)
    end
end
    current_road_test.localisations[1].latest_a = 0

    for i in 1:new_nb_loc
        if i == 1
            current_road_test.localisations[1].effective_d = current_road_test.localisations[1].latest_d
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_d - current_road_test.localisations[i].earliest_d
        elseif i != 1 && i != new_nb_loc
            current_road_test.localisations[i].effective_a = current_road_test.localisations[i-1].effective_d+times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
            for j in 1:size(daily_requests.daily_requests)[1]
                if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                    global TWA = daily_requests.daily_requests[j].TW_A_P
                elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                    global TWA = daily_requests.daily_requests[j].TW_A_D
                end
            current_road_test.localisations[i].start_service = max(current_road_test.localisations[i].effective_a,TWA)
            end
            current_road_test.localisations[i].effective_d = current_road_test.localisations[i].start_service + current_road_test.localisations[i].service_time
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_d - current_road_test.localisations[i].earliest_d

        elseif i == new_nb_loc
            current_road_test.localisations[i].effective_a = current_road_test.localisations[i-1].effective_d+times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_a - current_road_test.localisations[i].earliest_a
        end
    end

    #feasibility check of the insertion
    if current_road_test.localisations[new_nb_loc].effective_a - current_road_test.localisations[1].effective_d <= max_route_duration
        if current_road_test.localisations[1].effective_d >= 0
            if current_road_test.localisations[new_nb_loc].effective_a <= 720
               if all(current_road_test.localisations[i].effective_a >= current_road_test.localisations[i].earliest_a && current_road_test.localisations[i].effective_a <= current_road_test.localisations[i].latest_a for i in 1:new_nb_loc)
                   if all(current_road_test.localisations[i].effective_d >= current_road_test.localisations[i].earliest_d && current_road_test.localisations[i].effective_d <= current_road_test.localisations[i].latest_d for i in 1:new_nb_loc)
                        test = true
                        current_road = current_road_test
                        return (current_road,test)
                   else
                        return (current_road,test)
                    end
                else
                    return (current_road,test)
                end
            else
                #     println("This is not possible to insert the request in this road because it would lead the driver to work after the available working hours")
                return (current_road,test)
            end
        else
            #    println("This is not possible to insert the request in this road because it would lead the driver to work before the available working hours")
            return (current_road,test)
        end
    else
    #    println("This is not possible to insert the request in this road because it would lead the driver to work more than its maximum ride time")
        return (current_road,test)
        end
    end

function insert_request_D(current_road::Route,request::Request,indexD,daily_requests::DailyRequests,times_matrix,cap_vehicles_vector,max_route_duration)
    test = false
    current_road_test::Route = deepcopy(current_road)  #creation of a copy, if all the tests are ok, current_road will be replaced by current_road_test
    current_nb_loc = size(current_road_test.localisations)[1]
    index = indexD

    new_load_A = current_road_test.localisations[index-1].load_A-request.load_A
    new_load_B = current_road_test.localisations[index-1].load_B-request.load_B
    new_load_C = current_road_test.localisations[index-1].load_C-request.load_C
    e_arr = current_road_test.localisations[index-1].earliest_d + times_matrix[current_road_test.localisations[index-1].ID_loc+1,request.ID_loc_D+1]
    TWA = request.TW_A_D
    e_dep = max(TWA, e_arr) + request.service_time
    eff_a = current_road_test.localisations[index-1].effective_d + times_matrix[current_road_test.localisations[index-1].ID_loc+1,request.ID_loc_D+1]
    eff_d = eff_a + request.service_time
    start_service = max(eff_a,TWA) + request.service_time
    new_loc = Vec_Loc(index,request.ID_loc_D,request.ID_cust,e_arr,eff_a,0,start_service,request.service_time,e_dep,eff_d,0,0,new_load_A,new_load_B,new_load_C,request.ID_request,2)
    insert!(current_road_test.localisations,index,new_loc) #insertion of the delivery localisation in the testing road
    new_nb_loc = size(current_road_test.localisations)[1]

#UPDATE OF THE END OF THE ROUTE
for i in index+1:new_nb_loc-1
    current_road_test.localisations[i].ID_stop = i
    for j in 1:size(daily_requests.daily_requests)[1]
        if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
            current_road_test.localisations[i].load_A = current_road_test.localisations[i-1].load_A + daily_requests.daily_requests[j].load_A
            current_road_test.localisations[i].load_B = current_road_test.localisations[i-1].load_B + daily_requests.daily_requests[j].load_B
            current_road_test.localisations[i].load_C = current_road_test.localisations[i-1].load_C + daily_requests.daily_requests[j].load_C
        elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
            current_road_test.localisations[i].load_A = current_road_test.localisations[i-1].load_A - daily_requests.daily_requests[j].load_A
            current_road_test.localisations[i].load_B = current_road_test.localisations[i-1].load_B - daily_requests.daily_requests[j].load_B
            current_road_test.localisations[i].load_C = current_road_test.localisations[i-1].load_C - daily_requests.daily_requests[j].load_C
        end
    end
end
if all(current_road_test.localisations[i].load_A <= cap_vehicles_vector[1] for i in 1:new_nb_loc)
    if all(current_road_test.localisations[i].load_B <= cap_vehicles_vector[2] for i in 1:new_nb_loc)
        if all(current_road_test.localisations[i].load_C <= cap_vehicles_vector[3] for i in 1:new_nb_loc)
            test_cap = true
        #    println("capacities ar oke")
        else
            #   println("This is not possible to insert the request in this road because of a resource type C saturation somewhere")
                return (current_road,test)
            end
        else
         #  println("This is not possible to insert the request in this road because of a resource type B saturation somewhere")
            return (current_road,test)
            end
    else
     #  println("This is not possible to insert the request in this road because of a resource type A saturation somewhere")
        return (current_road,test)
        end
    current_road_test.localisations[new_nb_loc].ID_stop = new_nb_loc

if test_cap == true
    for i in 2:new_nb_loc
        current_road_test.localisations[i].earliest_a = current_road_test.localisations[i-1].earliest_d + times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
         for j in 1:size(daily_requests.daily_requests)[1]
             if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                 global TWA = daily_requests.daily_requests[j].TW_A_P
             elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                 global TWA = daily_requests.daily_requests[j].TW_A_D
             end
             if i != new_nb_loc
                 current_road_test.localisations[i].earliest_d = max(TWA,current_road_test.localisations[i].earliest_a) + current_road_test.localisations[i].service_time
             end
         end
     end

    for i in new_nb_loc-1:-1:1 #recomputation of latest arrival/departure times & slack times
        current_road_test.localisations[i].latest_d = current_road_test.localisations[i+1].latest_a - times_matrix[current_road_test.localisations[i+1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
        for j in 1:size(daily_requests.daily_requests)[1]
            if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                global TWB = daily_requests.daily_requests[j].TW_B_P
            elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                global TWB = daily_requests.daily_requests[j].TW_B_D
            end
        current_road_test.localisations[i].latest_a = min(current_road_test.localisations[i].latest_d-current_road_test.localisations[i].service_time, TWB)
        end
    end
    current_road_test.localisations[1].latest_a = 0

    for i in 1:new_nb_loc
        if i == 1
            current_road_test.localisations[1].effective_d = current_road_test.localisations[1].latest_d
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_d - current_road_test.localisations[i].earliest_d
        elseif i != 1 && i != new_nb_loc
            current_road_test.localisations[i].effective_a = current_road_test.localisations[i-1].effective_d+times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
            for j in 1:size(daily_requests.daily_requests)[1]
                if current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 1
                    global TWA = daily_requests.daily_requests[j].TW_A_P
                elseif current_road_test.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road_test.localisations[i].P_or_D == 2
                    global TWA = daily_requests.daily_requests[j].TW_A_D
                end
            current_road_test.localisations[i].start_service = max(current_road_test.localisations[i].effective_a,TWA)
            end
            current_road_test.localisations[i].effective_d = current_road_test.localisations[i].start_service + current_road_test.localisations[i].service_time
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_d - current_road_test.localisations[i].earliest_d

        elseif i == new_nb_loc
            current_road_test.localisations[i].effective_a = current_road_test.localisations[i-1].effective_d+times_matrix[current_road_test.localisations[i-1].ID_loc+1,current_road_test.localisations[i].ID_loc+1]
            current_road_test.localisations[i].current_slack_time = current_road_test.localisations[i].latest_a - current_road_test.localisations[i].earliest_a
        end
    end

    #check of maximum ride times

    counter = 0
    max_ride_times_verif = false
    for i in 1:size(daily_requests.daily_requests)[1]
        index_P = 0
        index_D = 0
        for j in 2:size(current_road_test.localisations)[1]-1
            if current_road_test.localisations[j].ID_request == daily_requests.daily_requests[i].ID_request && current_road_test.localisations[j].P_or_D == 1
                 index_P = j
            elseif current_road_test.localisations[j].ID_request == daily_requests.daily_requests[i].ID_request && current_road_test.localisations[j].P_or_D == 2
                index_D = j
            end
        end
        if (index_P > 0 && index_D > 0)
            if current_road_test.localisations[index_D].effective_a - current_road_test.localisations[index_P].effective_d <= daily_requests.daily_requests[i].max_ride_time
                 counter = counter+1
            end
        end
    end

    if counter == (size(current_road_test.localisations)[1]-2)/2
        global   max_ride_times_verif = true
    else
    end

    #feasibility check of the insertion
    if current_road_test.localisations[new_nb_loc].effective_a - current_road_test.localisations[1].effective_d <= max_route_duration
        if current_road_test.localisations[1].effective_d >= 0
            if current_road_test.localisations[new_nb_loc].effective_a <= 720
                if all(current_road_test.localisations[i].effective_a >= current_road_test.localisations[i].earliest_a && current_road_test.localisations[i].effective_a <= current_road_test.localisations[i].latest_a for i in 1:new_nb_loc)
                    if all(current_road_test.localisations[i].effective_d >= current_road_test.localisations[i].earliest_d && current_road_test.localisations[i].effective_d <= current_road_test.localisations[i].latest_d for i in 1:new_nb_loc)
                     if max_ride_times_verif == true
                            test = true
                            current_road = current_road_test
                            indicator = current_road_test.localisations[new_nb_loc].effective_a - current_road_test.localisations[1].effective_d
                        #    println("all is ok")
                            return (current_road,test,indicator)
                       else
                         #  println("max user ride time not ok")
                          return (current_road,test)

                      end
                    else
                    #    println("tw ok not")
                       return (current_road,test)

                    end
                else
                #    println("tw not ok")
                    return (current_road,test)
                end
            else
                #     println("This is not possible to insert the request in this road because it would lead the driver to work after the available working hours")
                return (current_road,test)
            end
        else
            #  println("This is not possible to insert the request in this road because it would lead the driver to work before the available working hours")
            return (current_road,test)
        end
    else
        #println("This is not possible to insert the request in this road because it would lead the driver to work more than its maximum ride time")
        return (current_road,test)
        end
else
    #println("cap not ok")
    return (current_road,test)

end
end

#--------------------FIND THE BEST INSERTION INDEXES FOR PICKUP AND DELIVERY IN A GIVEN ROUTE TO MINIMIZE THE TOTAL ROUTE DURATION---------------------------------------------#
function find_best_indexes(current_road::Route,request::Request,daily_requests::DailyRequests,times_matrix,cap_vehicles_vector,max_route_duration)
best_index_P = 0
best_index_D = 0
indexes_P = [] #will contain P indexes
indexes_D = [] #will contain D indexes
indicators = [] #will only contain indicatros

#REGISTER all possibilities
possibles_P = find_allindex_P(current_road,request,times_matrix)
test = false
for i in 1:size(possibles_P)[1]
test_insertion_P = insert_request_P(current_road,request,possibles_P[i],daily_requests,times_matrix,cap_vehicles_vector,max_route_duration)
    if test_insertion_P[2] == true
        new_road = test_insertion_P[1]
        possibles_D = find_allindex_D(new_road, request,times_matrix,possibles_P[i])
        for j in 1:size(possibles_D)[1]
            if possibles_D[j] > possibles_P[i]
            test_insertion_D = insert_request_D(new_road,request,possibles_D[j],daily_requests,times_matrix,cap_vehicles_vector,max_route_duration)
                if test_insertion_D[2] == true
                    indicator = test_insertion_D[3]
                    push!(indexes_P,possibles_P[i])
                    push!(indexes_D,possibles_D[j])
                    push!(indicators,indicator)
                    test = true
                else
                    test = false
                end
            else
                test = false
            end
        end
    else
        test = false
    end
end

#CHOOSE THE BEST COMBINATION
if !isempty(indicators)
    best_indexes = findmin(indicators)[2]
    best_index_P = indexes_P[best_indexes]
    best_index_D = indexes_D[best_indexes]
    test = true
    return (best_index_P,best_index_D,test)
else
    return (0,0,test)
end
end

#---------------------------------------------COMPUTATION OF DC_INDICATOR AND RB_INDICATOR-----------------------------------------------------------------------------------#
function indicators_comput(weekly_solution::Weekly_Sol, Nb_drivers,customers)
    nb_days = 5

    accumulated_ride_times = zeros(Nb_drivers)
    drivers_customers_assoc = Vector{Vector{Int64}}(undef,Nb_drivers) #will be first vector for first driver, etc

    for i in 1:length(drivers_customers_assoc)
        drivers_customers_assoc[i] = []
    end

    for d in 1:nb_days
        for t in 1:Nb_drivers
            nb_loc = size(weekly_solution.solutions[d].routes[t].localisations)[1]
            for k in 1:nb_loc
                if weekly_solution.solutions[d].routes[t].localisations[k].ID_cust != 0
                    push!(drivers_customers_assoc[t],weekly_solution.solutions[d].routes[t].localisations[k].ID_cust)
                end
            end
        ride = weekly_solution.solutions[d].routes[t].localisations[nb_loc].effective_a - weekly_solution.solutions[d].routes[t].localisations[1].effective_d
        accumulated_ride_times[t] = accumulated_ride_times[t] + ride
        end
    end

    customers_drivers = Vector{Vector{Int64}}(undef,customers) #will contain, at each index = customer, the indexes of drivers who took care of him
    for i in 1:length(customers_drivers)
        customers_drivers[i] = []
    end

    for c in 1:customers
        for d in 1:Nb_drivers
            if in(c, drivers_customers_assoc[d])
                push!(customers_drivers[c], d)
            end
        end
    end

    total_drivers = sum(length.(customers_drivers))
    DC_indicator = total_drivers/customers

    fairness_indicator = std(accumulated_ride_times)
    return (DC_indicator, fairness_indicator)
end
#---------------------------------------------------------------DELETE A REQUEST OF A ROUTE------------------------------------------------------------------------#
function delete_request(current_road::Route, request::Request, daily_requests::DailyRequests, times_matrix)
starting_nb_loc = size(current_road.localisations)[1]
    if starting_nb_loc <= 4 #if there is only one request in the road currently, cleaning of all the  road
        for i in starting_nb_loc:-1:2
            deleteat!(current_road.localisations,i) #delete all the localisations except the first
        end
        current_road.localisations[1].ID_stop = 0
        current_road.localisations[1].effective_d = 0
        current_road.localisations[1].latest_d = 0
        current_road.localisations[1].current_slack_time = 0

    elseif starting_nb_loc > 4 #if there is currently more than one request on the road
        for i in starting_nb_loc:-1:1 #pickup and delivery deleting
            if current_road.localisations[i].ID_request == request.ID_request
                deleteat!(current_road.localisations,i)
            end
        end
        nb_loc = size(current_road.localisations)[1]

        for i in 2:nb_loc-1 #UPDATE of the route
            current_road.localisations[i].ID_stop = i
            for j in 1:size(daily_requests.daily_requests)[1]
               if current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 1
                   current_road.localisations[i].load_A = current_road.localisations[i-1].load_A + daily_requests.daily_requests[j].load_A
                   current_road.localisations[i].load_B = current_road.localisations[i-1].load_B + daily_requests.daily_requests[j].load_B
                   current_road.localisations[i].load_C = current_road.localisations[i-1].load_C + daily_requests.daily_requests[j].load_C
               elseif current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 2
                   current_road.localisations[i].load_A = current_road.localisations[i-1].load_A - daily_requests.daily_requests[j].load_A
                   current_road.localisations[i].load_B = current_road.localisations[i-1].load_B - daily_requests.daily_requests[j].load_B
                   current_road.localisations[i].load_C = current_road.localisations[i-1].load_C - daily_requests.daily_requests[j].load_C
                   end
               end
           end
           current_road.localisations[nb_loc].ID_stop = nb_loc

           for i in 2:nb_loc
               current_road.localisations[i].earliest_a = current_road.localisations[i-1].earliest_d + times_matrix[current_road.localisations[i-1].ID_loc+1,current_road.localisations[i].ID_loc+1]
               for j in 1:size(daily_requests.daily_requests)[1]
                   if current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 1
                       global TWA = daily_requests.daily_requests[j].TW_A_P
                   elseif current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 2
                       global TWA = daily_requests.daily_requests[j].TW_A_D
                   end
                   if i != nb_loc
                    current_road.localisations[i].earliest_d = max(TWA,current_road.localisations[i].earliest_a) + current_road.localisations[i].service_time
                    end
                end
            end

            for i in nb_loc-1:-1:1 #recomputation of latest arrival/departure times & slack times
                current_road.localisations[i].latest_d = current_road.localisations[i+1].latest_a - times_matrix[current_road.localisations[i+1].ID_loc+1,current_road.localisations[i].ID_loc+1]
                for j in 1:size(daily_requests.daily_requests)[1]
                    if current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 1
                        global TWB = daily_requests.daily_requests[j].TW_B_P
                    elseif current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 2
                        global TWB = daily_requests.daily_requests[j].TW_B_D
                    end
                    current_road.localisations[i].latest_a = min(current_road.localisations[i].latest_d-current_road.localisations[i].service_time, TWB)
                end
            end
            current_road.localisations[1].latest_a = 0

            for i in 1:nb_loc
                if i == 1
                    current_road.localisations[1].effective_d = current_road.localisations[1].latest_d
                elseif i != 1 && i != nb_loc
                    current_road.localisations[i].effective_a = current_road.localisations[i-1].effective_d+times_matrix[current_road.localisations[i-1].ID_loc+1,current_road.localisations[i].ID_loc+1]
                    for j in 1:size(daily_requests.daily_requests)[1]
                        if current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 1
                            global TWA = daily_requests.daily_requests[j].TW_A_P
                        elseif current_road.localisations[i].ID_request == daily_requests.daily_requests[j].ID_request && current_road.localisations[i].P_or_D == 2
                            global TWA = daily_requests.daily_requests[j].TW_A_D
                        end
                    current_road.localisations[i].start_service = max(current_road.localisations[i].effective_a,TWA)
                    end
                    current_road.localisations[i].effective_d = current_road.localisations[i].start_service + current_road.localisations[i].service_time
                    current_road.localisations[i].current_slack_time = current_road.localisations[i].latest_d - current_road.localisations[i].earliest_d

                elseif i == nb_loc
                    current_road.localisations[i].effective_a = current_road.localisations[i-1].effective_d+times_matrix[current_road.localisations[i-1].ID_loc+1,current_road.localisations[i].ID_loc+1]
                    current_road.localisations[i].current_slack_time = current_road.localisations[i].latest_a - current_road.localisations[i].earliest_a
                end
            end
    end
    return current_road
end

#----------------------------------------------------NEIGHBORHOOD STRUCTURE FOCUSING ON ROUTE BALALNCING------------------------------------------------------------#
function neighbor_fairness(starting_weekly_sols,weekly_requests,times_matrix,cap_vehicles,max_route_duration,Nb_drivers,Nb_cust)
    starting_weekly_sol = starting_weekly_sols[1]
    accumulated_ride_times = zeros(Nb_drivers)
    counter_requests = zeros(Nb_drivers)
    ID_requests = Vector{Vector{Int64}}(undef, Nb_drivers)
    for i in eachindex(ID_requests)
        ID_requests[i] = Int[]
    end

    for d in 1:5
        for t in 1:Nb_drivers
            nb_loc = size(starting_weekly_sol.solutions[d].routes[t].localisations)[1]
            ride = starting_weekly_sol.solutions[d].routes[t].localisations[nb_loc].effective_a - starting_weekly_sol.solutions[d].routes[t].localisations[1].effective_d
            accumulated_ride_times[t] = accumulated_ride_times[t] + ride
            counter_requests[t] = counter_requests[t] + (nb_loc-2)/2
            for k in 1:nb_loc
                push!(ID_requests[t], starting_weekly_sol.solutions[d].routes[t].localisations[k].ID_request)
            end
        end
    end

    driver_max = argmax(accumulated_ride_times)  #find the index of the driver who drives the most over the week
    ID_requests_driver = ID_requests[driver_max] #ID of requests satisfied by driver_max over the week
    ID_requests_driver = unique(ID_requests_driver) #delete of doublons
    ID_requests_driver = filter(x -> x != 0,ID_requests_driver) #delete of depots

    #selection of a random request
    request_selected = ID_requests_driver[rand(1:length(ID_requests_driver))]
    request_selected2 = 0 #will register the corresponding inbound/outbound travel if the driver has it

    #cneck if the driver has the corresponding inbound/outbound request of the same customer
    other_travel = false
    if (request_selected%2) == 1  #if the request is an odd number and thus it is an outbound travel
        if request_selected+1 in ID_requests_driver
            other_travel = true
            request_selected2 = request_selected+1
        end
    elseif (request_selected%2) == 0 #if the request is an even number and thus it is an inbound travel
        if request_selected-1 in ID_requests_driver
            other_travel = true
            request_selected2 = request_selected-1
        end
    end
    requests = sort(unique([request_selected,request_selected2]))

    drivers_ordered = []
    t=1
    while t < Nb_drivers
        accumulated_ride_times[driver_max] = 10000 #not chose it in the process
        index = findmin(accumulated_ride_times)[2]
        push!(drivers_ordered,index)
        accumulated_ride_times[index] = 10000 #cannot be choosen as the minimum anymore
        t = t+1
    end
    push!(drivers_ordered, driver_max) #put the initial driver who had the road normally at the end to come back to him if any insertion is feasible
    days = []

    for d in 1:5
        nb_loc = size(starting_weekly_sol.solutions[d].routes[driver_max].localisations)[1]
        for k in 1:nb_loc
            if starting_weekly_sol.solutions[d].routes[driver_max].localisations[k].ID_request == request_selected
                day1 = d
                push!(days,day1)
            end
            if request_selected2 != 0
                if starting_weekly_sol.solutions[d].routes[driver_max].localisations[k].ID_request == request_selected2
                    day2 = d
                    push!(days, day2)
                end
            end
        end
    end
    days = unique(days)
    days = sort(days)

    requests = sort(unique([request_selected,request_selected2]))

    counters = zeros(size(days)[1])
    for i in 1:size(counters)[1]
        nb_loc = size(starting_weekly_sol.solutions[days[i]].routes[driver_max].localisations)[1]
        for k in 1:nb_loc
            for r in 1:size(requests)[1]
                if starting_weekly_sol.solutions[days[i]].routes[driver_max].localisations[k].ID_request == requests[r]
                    counters[i] = counters[i] +1
                end
            end
        end
    end
    weekly_neighbor_copy = deepcopy(starting_weekly_sol)

    #deleting of request_selected and request_selected2 if the driver has it on the concerned days
    request1 = 0
    for d in 1:size(days)[1]
        for r in 1:size(requests)[1]
            nb_loc = size(weekly_neighbor_copy.solutions[days[d]].routes[driver_max].localisations)[1]
            if nb_loc >= 4
                for k in nb_loc:-1:1
                    if size(weekly_neighbor_copy.solutions[days[d]].routes[driver_max].localisations)[1] >= k
                        if weekly_neighbor_copy.solutions[days[d]].routes[driver_max].localisations[k].ID_request == requests[r]
                            for j in 1:size(weekly_requests.weekly_requests[days[d]].daily_requests)[1]
                                if weekly_requests.weekly_requests[days[d]].daily_requests[j].ID_request == requests[r]
                                    request1 = weekly_requests.weekly_requests[days[d]].daily_requests[j]
                            end
                        end
                    end
                    if request1 != 0
                        weekly_neighbor_copy.solutions[days[d]].routes[driver_max] = delete_request(weekly_neighbor_copy.solutions[days[d]].routes[driver_max],request1, weekly_requests.weekly_requests[days[d]],times_matrix)
                    end
                end
                end
            end
        end
    end

    weekly_neighbor_copy2 = deepcopy(weekly_neighbor_copy)

    #resinsertion to the drivers, in the order of accumulated ride times ascendant
    i = 1
    j = 1
    request = 0
    while (i <= size(drivers_ordered)[1])
        m = drivers_ordered[i]
        j = 1
        while (j <= size(days)[1])
            d = days[j]
            counter = 0
            for r in 1:size(requests)[1]
                insertion_request = false
                for k in 1:size(weekly_requests.weekly_requests[d].daily_requests)[1]
                    if weekly_requests.weekly_requests[d].daily_requests[k].ID_request == requests[r]
                        request = weekly_requests.weekly_requests[d].daily_requests[k]
                    end
                end

                if size(weekly_neighbor_copy2.solutions[d].routes[m].localisations)[1] == 1 #if the driver still does not have localisations on its road
                    test_insertion = initialization_road(weekly_neighbor_copy2.solutions[d].routes[m],request,times_matrix)
                    if test_insertion[2] == true
                        insertion_request = true
                        weekly_neighbor_copy2.solutions[d].routes[m] = test_insertion[1]
                        counter = counter + 2
                    elseif test_insertion[2] == false
                        insertion_request == false
                    end
                else
                    if request != 0
                    best_indexes = find_best_indexes(weekly_neighbor_copy2.solutions[d].routes[m], request, weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)
                    if best_indexes[3] == true
                        indexP = best_indexes[1]
                        indexD = best_indexes[2]
                        interm_route = insert_request_P(weekly_neighbor_copy2.solutions[d].routes[m],request,indexP,weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)[1]
                        weekly_neighbor_copy2.solutions[d].routes[m] = insert_request_D(interm_route,request,indexD,weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)[1]
                        insertion_request = true
                        counter = counter + 2
                    elseif best_indexes[3] == false
                        insertion_request = false
                    end
                    end
                end
                if insertion_request == false
                    counter = 0
                end
            end
            if counter != counters[j]
                counter = 0
            end

            if j < size(days)[1] && counter == counters[j]
                    j = j+1
            elseif j == size(days)[1] && counter == counters[j]
                test = true
                indicators = indicators_comput(weekly_neighbor_copy,Nb_drivers,Nb_cust)
                indicator_DC = indicators[1]
                indicator_fairness = indicators[2]
                return (weekly_neighbor_copy2,indicator_DC,indicator_fairness)
            elseif counter != counters[j] && i < size(drivers_ordered)[1]
                i = i+1
                weekly_neighbor_copy2 = deepcopy(weekly_neighbor_copy)
                break
            elseif counter != counters[j] && i == size(drivers_ordered)[1]
                test = false
                return (starting_weekly_sols)
            end
        end
    end
end
#-----------------------------------------------------NEIGHBORHOOD STRUCTURE FOCUSING ON DRIVER CONSISTENCY-----------------------------------------------------------------------#
function neighbor_drivers(starting_weekly_sols,weekly_requests,times_matrix,cap_vehicles,max_route_duration,Nb_drivers,Nb_cust)
nb_days = 5
starting_weekly_sol = starting_weekly_sols[1]

#STEP 1: find the customer who sees the more different driver over the week
drivers_customers_assoc = Vector{Vector{Int64}}(undef,Nb_drivers) #will be first vector for first driver, etc

for i in 1:length(drivers_customers_assoc)
    drivers_customers_assoc[i] = []
end

for d in 1:nb_days
    for t in 1:Nb_drivers
        nb_loc = size(starting_weekly_sol.solutions[d].routes[t].localisations)[1]
        for k in 1:nb_loc
            if starting_weekly_sol.solutions[d].routes[t].localisations[k].ID_cust != 0
                push!(drivers_customers_assoc[t],starting_weekly_sol.solutions[d].routes[t].localisations[k].ID_cust)
            end
        end
    end
end

customers_drivers = Vector{Vector{Int64}}(undef,customers) #will contain, at each index = customer, the indexes of drivers who took care of him
for i in 1:length(customers_drivers)
    customers_drivers[i] = []
end
for c in 1:customers
    for d in 1:Nb_drivers
        if in(c, drivers_customers_assoc[d])
            push!(customers_drivers[c], d)
        end
    end
end
max_cust = argmax(length.(customers_drivers))
drivers_seen = customers_drivers[max_cust]

#STEP 2 = random choice of a driver to delete from the customer's week and update of the list
chosen_index = rand(1:length(drivers_seen))
selected_driver = drivers_seen[chosen_index]
drivers_seen_rest = deepcopy(drivers_seen)
drivers_seen_rest = deleteat!(drivers_seen_rest,chosen_index)

#STEP 3 = finding the requests to delete from the selected_driver road including max_cust and the concerned days
ID_requests = []
days = []
for d in 1:nb_days
    nb_loc = size(starting_weekly_sol.solutions[d].routes[selected_driver].localisations)[1]
    for k in 1:nb_loc
        if starting_weekly_sol.solutions[d].routes[selected_driver].localisations[k].ID_cust == max_cust
            push!(ID_requests,starting_weekly_sol.solutions[d].routes[selected_driver].localisations[k].ID_request)
            push!(days,d)
        end
    end
end
ID_requests = unique(ID_requests)
days = unique(days)

#STEP 4 = classement of the drivers according to their current total ride time
accumulated_ride_times = zeros(Nb_drivers)

for d in 1:5
    for t in 1:Nb_drivers
        nb_loc = size(starting_weekly_sol.solutions[d].routes[t].localisations)[1]
        ride = starting_weekly_sol.solutions[d].routes[t].localisations[nb_loc].effective_a - starting_weekly_sol.solutions[d].routes[t].localisations[1].effective_d
        accumulated_ride_times[t] = accumulated_ride_times[t] + ride
    end
end



drivers_ordered = []
test = []
indices = []

for i in 1:Nb_drivers
    if i in drivers_seen_rest
        push!(test, accumulated_ride_times[i])
        push!(indices, i)
    end
end

i = 1
while i <= size(drivers_seen_rest)[1]
    index = findmin(test)[2]
    driver = indices[index]
    push!(drivers_ordered, driver)
    test[index] = 100000
    i = i+1
    accumulated_ride_times[driver] = 100000
end

t=1
while t <= Nb_drivers-size(drivers_seen_rest)[1]
    index = findmin(accumulated_ride_times)[2]
    push!(drivers_ordered,index)
    accumulated_ride_times[index] = 10000 #cannot be choosen as the minimum anymore
    t = t+1
end

#STEP 5 : obtain the number of daily localisations to remove/readd
counters = zeros(size(days)[1])
for i in 1:size(counters)[1]
    nb_loc = size(starting_weekly_sol.solutions[days[i]].routes[selected_driver].localisations)[1]
    for k in 1:nb_loc
        for r in 1:size(ID_requests)[1]
            if starting_weekly_sol.solutions[days[i]].routes[selected_driver].localisations[k].ID_request == ID_requests[r]
                counters[i] = counters[i] +1
            end
        end
    end
end

#STEP 6 : copy of the starting solution
weekly_neighbor_copy = deepcopy(starting_weekly_sol)

#STEP 7 : delete of the corresponding locations of the routes of selected_driver on the concerned days
request1 = 0
for d in 1:size(days)[1]
    for r in 1:size(ID_requests)[1]
        nb_loc = length(weekly_neighbor_copy.solutions[days[d]].routes[selected_driver].localisations)
        if nb_loc >= 4
            for k in nb_loc:-1:1
                if size(weekly_neighbor_copy.solutions[days[d]].routes[selected_driver].localisations)[1] >= k
                    if weekly_neighbor_copy.solutions[days[d]].routes[selected_driver].localisations[k].ID_request == ID_requests[r]
                        for j in 1:size(weekly_requests.weekly_requests[days[d]].daily_requests)[1]
                            if weekly_requests.weekly_requests[days[d]].daily_requests[j].ID_request == ID_requests[r]
                                request1 = weekly_requests.weekly_requests[days[d]].daily_requests[j]
                            end
                        end
                    end
                if request1 != 0
                    weekly_neighbor_copy.solutions[days[d]].routes[selected_driver] = delete_request(weekly_neighbor_copy.solutions[days[d]].routes[selected_driver],request1, weekly_requests.weekly_requests[days[d]],times_matrix)
                end
            end
        end
        end
    end
end

weekly_neighbor_copy2 = deepcopy(weekly_neighbor_copy)

#STEP 8 resinsertion to the drivers, in the order of accumulated ride times ascendant
i = 1
j = 1
request = 0
while (i <= size(drivers_ordered)[1])
    m = drivers_ordered[i]
    j = 1
    while (j <= size(days)[1])
        d = days[j]
        counter = 0
        for r in 1:size(ID_requests)[1]
            insertion_request = false
            for k in 1:size(weekly_requests.weekly_requests[d].daily_requests)[1]
                if weekly_requests.weekly_requests[d].daily_requests[k].ID_request == ID_requests[r]
                    request = weekly_requests.weekly_requests[d].daily_requests[k]
                end
            end

            if size(weekly_neighbor_copy2.solutions[d].routes[m].localisations)[1] == 1 #if the driver still does not have localisations on its road
                test_insertion = initialization_road(weekly_neighbor_copy2.solutions[d].routes[m],request,times_matrix)
                if test_insertion[2] == true
                    insertion_request = true
                    weekly_neighbor_copy2.solutions[d].routes[m] = test_insertion[1]
                    counter = counter + 2
                elseif test_insertion[2] == false
                    insertion_request == false
                end
            else
                best_indexes = find_best_indexes(weekly_neighbor_copy2.solutions[d].routes[m], request, weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)
                if best_indexes[3] == true
                    indexP = best_indexes[1]
                    indexD = best_indexes[2]
                    interm_route = insert_request_P(weekly_neighbor_copy2.solutions[d].routes[m],request,indexP,weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)[1]
                    weekly_neighbor_copy2.solutions[d].routes[m] = insert_request_D(interm_route,request,indexD,weekly_requests.weekly_requests[d],times_matrix,cap_vehicles,max_route_duration)[1]
                    insertion_request = true
                    counter = counter + 2
                elseif best_indexes[3] == false
                    insertion_request = false
                end
            end
            if insertion_request == false
                counter = 0
            end
        end
        if counter != counters[j]
            counter = 0
        end

        if j < size(days)[1] && counter == counters[j]
            j = j+1
        elseif j == size(days)[1] && counter == counters[j]
            test = true
            indicators = indicators_comput(weekly_neighbor_copy2,Nb_drivers,Nb_cust)
            indicator_DC = indicators[1]
            indicator_fairness = indicators[2]
            return (weekly_neighbor_copy2,indicator_DC,indicator_fairness)
        elseif counter != counters[j] && i < size(drivers_ordered)[1]
            i = i+1
            weekly_neighbor_copy2 = deepcopy(weekly_neighbor_copy)
            break
        elseif counter != counters[j] && i == size(drivers_ordered)[1]
            test = false
            return starting_weekly_sols
        end
    end
end
end

#------------------------------------------------DRIVERS PRIOTIY FUNCTION FOR THE INITIAL SOLUTION CREATION METHOD ---------------------------------------------#
function drivers_priority2(weekly_routes::Weekly_Sol)
Nb_drivers = size(weekly_routes.solutions[1].routes)[1]
vec_prio = []
accumulated_ride_times = zeros(Nb_drivers)

for d in 1:5
    for t in 1:Nb_drivers
        nb_loc = size(weekly_routes.solutions[d].routes[t].localisations)[1]
        ride = weekly_routes.solutions[d].routes[t].localisations[nb_loc].effective_a - weekly_routes.solutions[d].routes[t].localisations[1].effective_d
        accumulated_ride_times[t] = accumulated_ride_times[t] + ride
    end
end

i = 1
while (i<=Nb_drivers)
    min_index = findmin(accumulated_ride_times)[2]
    push!(vec_prio, min_index)
    accumulated_ride_times[min_index] = 10000000000000000000 #cannot be chosen as the minimum anymore
    i = i+1
end
    return vec_prio
end

#--------------------------------FUNCTION TO MAKE A NEW STRUCTURE OF WEEKLY SOL FOR A CUSTOMER IN AN INSTANCE---------------------------------------#
function customer_weekly_requests(weekly_requests::WeeklyRequests,ID_cust)
customer_weekly_req = deepcopy(weekly_requests)

for d in 1:5
    for r in size(customer_weekly_req.weekly_requests[d].daily_requests)[1]:-1:1
        if customer_weekly_req.weekly_requests[d].daily_requests[r].ID_cust != ID_cust
            deleteat!(customer_weekly_req.weekly_requests[d].daily_requests,r)
        end
    end
end
    return customer_weekly_req
end

#----------------------------------------ALL CUSTOMERS REQUESTS FOR A WEEK CLUSTERED BY CUSTOMER----------------------------------------------------#
function customers_weekly_requests_split(weekly_requests::WeeklyRequests, Nb_cust)
cust_weekly_requests = []
for c in 1:Nb_cust
    weekly_req = customer_weekly_requests(weekly_requests,c)
    push!(cust_weekly_requests, weekly_req)
end
return cust_weekly_requests
end

#----------------------------------------------------------CUSTOMERS SORTING---------------------------------------------------------------------#
function customers_sorting(weekly_requests, Nb_cust)
    nb_requests = zeros(Nb_cust)
    customers = []
    for c in 1:Nb_cust
        for d in 1:5
            for k in 1:size(weekly_requests.weekly_requests[d].daily_requests)[1]
                if weekly_requests.weekly_requests[d].daily_requests[k].ID_cust == c
                    nb_requests[c] = nb_requests[c]+1
                end
            end
        end
    end

    for c in 1:Nb_cust
        cust_selected = findmax(nb_requests)[2]
        push!(customers, cust_selected)
        nb_requests[cust_selected] = 0 #not choose it anymore
    end

return customers

end

#-----------------------------------------------------INITIAL SOLUTION METHOD-----------------------------------------------------------------#
function weekly_initial_solution2(weekly_requests::WeeklyRequests, Nb_drivers, Nb_cust)

#initialization of empty roads for all the week (number = number of vehicles)
initial_routes = []
for d in 1:5
    routes= []
    for i in 1:Nb_drivers
        vec =Vec_Loc(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        route = [vec]
        route = Route(route)
        push!(routes, route)
     end
     initial_routess = Daily_Sol(routes)
     push!(initial_routes,initial_routess)
 end
current_weekly_routes = Weekly_Sol(initial_routes)

weekly_cust_requests =  customers_weekly_requests_split(weekly_requests, Nb_cust)

customers = customers_sorting(weekly_requests, Nb_cust)

l=1
missing_custs = []
while (l <= Nb_cust)
    i = customers[l]
    weekly_requests_cust = weekly_cust_requests[i]
    counters = zeros(5)
    for d in 1:5
        counters[d] = size(weekly_requests_cust.weekly_requests[d].daily_requests)[1]*2 #REGISTER the number of LOCATIONS to put on each road
    end
    drivers_ordered = drivers_priority2(current_weekly_routes)
    j = 1
    m = drivers_ordered[j]
    insertion_requestss = false
    current_weekly_test = deepcopy(current_weekly_routes)
    while (insertion_requestss == false & j <= Nb_drivers)
        counts = zeros(5)
        for d in 1:5
        if counters[d] > 0
            for r in 1:size(weekly_requests_cust.weekly_requests[d].daily_requests)[1]
                if size(current_weekly_test.solutions[d].routes[m].localisations)[1] == 1
                    test_insertion = initialization_road(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r],times_matrix)
                    if test_insertion[2] == true
                        current_weekly_test.solutions[d].routes[m] = test_insertion[1]
                        counts[d] = counts[d] + 2
                    #    println("The request $r was integrated to road $m on day $d")
                    elseif test_insertion[2] == false
                        #println("The request $r was not integrated to road $m on day $d")
                        j = j + 1
                    end
                else
                    best_indexes = find_best_indexes(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r], weekly_requests.weekly_requests[d], times_matrix, Cap_vehicles[m,:], max_route_duration)
                    if best_indexes[3] == true
                        indexP = best_indexes[1]
                        indexD = best_indexes[2]
                        interm_route = insert_request_P(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r], indexP, weekly_requests.weekly_requests[d],times_matrix, Cap_vehicles[m,:], max_route_duration)[1]
                        current_weekly_test.solutions[d].routes[m] = insert_request_D(interm_route, weekly_requests_cust.weekly_requests[d].daily_requests[r], indexD, weekly_requests.weekly_requests[d],times_matrix, Cap_vehicles[m,:], max_route_duration)[1]
                        counts[d] = counts[d] + 2
                        #println("The request $r was integrated to road $m on day $d")
                    elseif best_indexes[3] == false
                        #println("The request $r was not integrated to road $m on day $d")
                    end
                end
            end
        end
    end
    test = 0
    for d in 1:5
        if counters[d] == counts[d]
            test = test + 1
        end
    end
    if test == 5
        l = l +1
        insertion_requestss = true
        current_weekly_routes = deepcopy(current_weekly_test)
    elseif test != 5 && j < Nb_drivers
        j = j+1
    elseif test != 5 && j == Nb_drivers
        push!(missing_custs, i)
        l = l+1
        break
    end
end
end


k=1
while (k <= size(missing_custs)[1])
    i = missing_custs[k]
    weekly_requests_cust = weekly_cust_requests[i]
    counters = zeros(5)
    for d in 1:5
        counters[d] = size(weekly_requests_cust.weekly_requests[d].daily_requests)[1]*2 #REGISTER the number of LOCATIONS to put on each road
    end
    for d in 1:5
        if counters[d] > 0
            accepted = []
            for r in 1:size(weekly_requests_cust.weekly_requests[d].daily_requests)[1]
                j = 1
                drivers_ordered = drivers_priority2(current_weekly_routes)
                insertion_request = false
                current_weekly_test = deepcopy(current_weekly_routes)
                counts = 0
                if weekly_requests_cust.weekly_requests[d].daily_requests[r].ID_request % 2 == 0
                    if in(weekly_requests_cust.weekly_requests[d].daily_requests[r].ID_request-1, accepted)
                        trial = true
                    else
                        trial = false
                    end
                elseif in(weekly_requests_cust.weekly_requests[d].daily_requests[r].ID_request, accepted)
                    trial = false
                else
                    trial = true
                end
            if trial == true
                   while (insertion_request == false && j <= Nb_drivers)
                        m = drivers_ordered[j]
                        #println("r = $r ")
                        #println("m = $m")
                        if size(current_weekly_test.solutions[d].routes[m].localisations)[1]  == 1
                            test_insertion = initialization_road(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r],times_matrix)
                            if test_insertion[2] == true
                                current_weekly_test.solutions[d].routes[m] = test_insertion[1]
                                counts = counts + 2
                                current_weekly_routes = deepcopy(current_weekly_test)
                                #println("The request $r was integrated to road $m on day $d")
                                push!(accepted, weekly_requests_cust.weekly_requests[d].daily_requests[r].ID_request)
                                insertion_request = true
                            elseif test_insertion[2] == false
                                #println("The request $r was not integrated to road $m on day $d")
                                if j < Nb_drivers
                                    j = j + 1
                                else
                                    println("the request $r was not integrated to any road on day $d")
                                    break
                                end
                            end
                        else
                            best_indexes = find_best_indexes(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r], weekly_requests.weekly_requests[d], times_matrix, Cap_vehicles[m,:], max_route_duration)
                            if best_indexes[3] == true
                                indexP = best_indexes[1]
                                indexD = best_indexes[2]
                                interm_route = insert_request_P(current_weekly_test.solutions[d].routes[m], weekly_requests_cust.weekly_requests[d].daily_requests[r], indexP, weekly_requests.weekly_requests[d],times_matrix, Cap_vehicles[m,:], max_route_duration)[1]
                                current_weekly_test.solutions[d].routes[m] = insert_request_D(interm_route, weekly_requests_cust.weekly_requests[d].daily_requests[r], indexD, weekly_requests.weekly_requests[d],times_matrix, Cap_vehicles[m,:], max_route_duration)[1]
                                counts = counts + 2
                                push!(accepted, weekly_requests_cust.weekly_requests[d].daily_requests[r].ID_request)
                                insertion_request = true
                                current_weekly_routes = deepcopy(current_weekly_test)
                                #println("The request $r was integrated to road $m on day $d")
                            elseif best_indexes[3] == false
                                if  j < Nb_drivers
                                    j = j+1
                                    #println("The request $r was not integrated to road $m on day $d")
                                else
                                    println("The request $r was not integrated to any road on day $d")
                                    break
                                end
                            end
                        end
                    end
                end
            end
        end
    end
k = k+1
end
indicators = indicators_comput(current_weekly_routes, Nb_drivers, Nb_cust)

return (current_weekly_routes, indicators[1], indicators[2])
end

#-----------------------------------------OBTENTION OF THE NUMBER OF DRIVERS ECOUNTERED PER PATIENT FOR ALL PATIENTS-------------------------------------------------#
function indicator_DC_comput(weekly_solution::Weekly_Sol, Nb_drivers,customers)
    nb_days = 5

    drivers_customers_assoc = Vector{Vector{Int64}}(undef,Nb_drivers) #will be first vector for first driver, etc

    for i in 1:length(drivers_customers_assoc)
        drivers_customers_assoc[i] = []
    end

    for d in 1:nb_days
        for t in 1:Nb_drivers
            nb_loc = size(weekly_solution.solutions[d].routes[t].localisations)[1]
            for k in 1:nb_loc
                if weekly_solution.solutions[d].routes[t].localisations[k].ID_cust != 0
                    push!(drivers_customers_assoc[t],weekly_solution.solutions[d].routes[t].localisations[k].ID_cust)
                end
            end
        end
    end

    customers_drivers = Vector{Vector{Int64}}(undef,customers) #will contain, at each index = customer, the indexes of drivers who took care of him
    for i in 1:length(customers_drivers)
        customers_drivers[i] = []
    end

    for c in 1:customers
        for d in 1:Nb_drivers
            if in(c, drivers_customers_assoc[d])
                push!(customers_drivers[c], d)
            end
        end
    end

    total_drivers = sum(length.(customers_drivers))
    DC_indicator = total_drivers/customers

    return (DC_indicator, customers_drivers)
end


#DISTANCE/TIME COMPUTATION BEWTEEN LOCATIONS & TRASNFORMATION OF (x,y) PAIRS FROM THE XLSX FILE INTO NUMBERS
vec_x = Matrix_requests[:,3]
vec_y = Matrix_requests[:,4]
insert!(vec_x,1,0.00)
insert!(vec_y,1,0.00)
times_matrix = times_computation(vec_x,vec_y,speed)
loc_to_num_matrix = loc_to_num(vec_x,vec_y,Matrix_requests)
Matrix_requests_num = loc_to_num_inmatrix(vec_x,vec_y,loc_to_num_matrix,Matrix_requests)

#OBTENTION OF DAILY REQUESTS TABLES/LISTS
monday = requests_list(daily_requests(1,Matrix_requests_num))
tuesday = requests_list(daily_requests(2,Matrix_requests_num))
wednesday = requests_list(daily_requests(3,Matrix_requests_num))
thursday = requests_list(daily_requests(4,Matrix_requests_num))
friday = requests_list(daily_requests(5,Matrix_requests_num))
days = [monday,tuesday,wednesday,thursday,friday]
weekly_requests = WeeklyRequests(days)

#--------------------------------------------------------------INITIAL SOLUTIONS PRINT IN EXCEL-------------------------------------------------------------------------#

initial_weekly_sol = weekly_initial_solution2(weekly_requests,Nb_drivers,customers)
initial_weekly_sols = weekly_initial_solution2(weekly_requests,Nb_drivers,customers)[1]
DC_indicator = weekly_initial_solution2(weekly_requests,Nb_drivers,customers)[2]
RB_indicator = weekly_initial_solution2(weekly_requests,Nb_drivers,customers)[3]

xfilename = "initial_solution_instance_$instance.routes.xlsx"
xfilename2 = "initial_solution_instance_$instance.indicators.xlsx"
initialsol = DataFrame(Day = [], Driver = [], ID_stop=[],ID_loc=[],ID_cust=[], earliest_a=[], effective_a=[],latest_a=[],start_service=[],service_time=[],earliest_d=[],effective_d=[],latest_d=[],current_slack_time=[],load_A=[],load_B=[],load_C=[],ID_request=[], P_or_D=[])
initial_ind = DataFrame(DC_indicator = [], RB_indicator = [])

for ind in keys(initial_weekly_sols.solutions)
    for inx in keys(initial_weekly_sols.solutions[ind].routes)
        for loc in keys(initial_weekly_sols.solutions[ind].routes[inx].localisations)
            day = ind
            driver = inx
            ID_stop = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].ID_stop
            ID_loc = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].ID_loc
            ID_cust = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].ID_cust
            earliest_a = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].earliest_a
            effective_a = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].effective_a
            latest_a = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].latest_a
            start_service = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].start_service
            service_time = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].service_time
            earliest_d = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].earliest_d
            effective_d = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].effective_d
            latest_d = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].latest_d
            current_slack_time = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].current_slack_time
            load_A = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].load_A
            load_B = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].load_B
            load_C = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].load_C
            ID_request = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].ID_request
            P_or_D = initial_weekly_sols.solutions[ind].routes[inx].localisations[loc].P_or_D
            push!(initialsol, [day, driver, ID_stop, ID_loc, ID_cust, earliest_a, effective_a, latest_a, start_service, service_time, earliest_d, effective_d,latest_d,current_slack_time,load_A,load_B,load_C,ID_request,P_or_D])
        end
    end
end

push!(initial_ind, [DC_indicator, RB_indicator])
XLSX.writetable(xfilename, Initial_sol=(collect(DataFrames.eachcol(initialsol)), DataFrames.names(initialsol)))
XLSX.writetable(xfilename2, Initial_ind = (collect(DataFrames.eachcol(initial_ind)), DataFrames.names(initial_ind)))

#-----------------------------------------------SIMULATED ANNEALING - HIGHER-LEVEL OBJECTIVE (driver consistency) -----------------------------------------------------------#
for run in 1:8  #each instance is run 8 times
#Parameters tuning
alpha = 0.8
epsilon = 0.05
K = 1
L = Nb_drivers
p = 0.5
best_DC_start = 10000

#Vectors that will allow us to find the best solution:
DC_indicators = [] #vector that will contain all the DC indicators that we'll find
weekly_sols = [] #vector that will contain all the weekly routes/schedules that we'll find
RB_indicators = []

#Counters initialization
k = 1 #1 for the first neighbor, 0 after (allow to define T(0) regarding p(0))
initial_weekly_sols = weekly_initial_solution2(weekly_requests,Nb_drivers,Nb_cust) #initial solution creation
current_weekly_sols = initial_weekly_sols
current_weekly_sol = current_weekly_sols[1]
current_DC_indicator = initial_weekly_sols[2]
current_RB_indicator = initial_weekly_sols[3]
push!(DC_indicators, current_DC_indicator)
push!(weekly_sols, current_weekly_sol)
push!(RB_indicators, current_RB_indicator)
iteration = 1 #will count the total number of iterations
sub_iteration = 1 #will count the number of iterations until L, in order to know when to change of plateau (so become 0 after L iterations)
cost_decrased_sols = 0 #will count the number of solutions that are accepted because they allow to decrease the cost, until we've to look at the stopping conditions (so become 0 after K*L iterations)
cost_increased_sols = 0 #will count the number of solutions that are accepted even if they increase the cost, until we've to look at the stopping conditions (so become 0 after K*L iterations)
stopping_criteria = 0 #will count the number of iterations in order to know if we have to look at the stopping conditions (so become 0 after K*L iterations)
algorithm = 0 #define if we continue to run the algorithm; 0 if yes, 1 otherwise

#Start of the algorithm loop
t1 = time() #register the starting time of the algorithm
while algorithm < 1 #as long as we have to continue to run the algorithm...
    #creation of a neighbor starting from our current solution, based on the neighborhoord structure focused on driver consistency
    neighbor = neighbor_drivers(current_weekly_sols,weekly_requests,times_matrix,cap_vehicles,max_route_duration,Nb_drivers,Nb_cust)
    new_current_solution = neighbor[1]
    new_DC_indicator = neighbor[2]
    new_RB_indicator = neighbor[3]
    improve = 0 #will serve to register is the best solution found so far improves or not
    #comparison of the new obtained solution with the previous one

    println("The initial DC indicator from the precedent solution was $current_DC_indicator")
    println("The new DC indicator from this neighbor is $new_DC_indicator")

    delta = abs(new_DC_indicator - current_DC_indicator) #computation of delta

    if k == 1 #computation of T(0) thanks to p(0), works only for the first iteration
        global T = -(delta/log(p))  #our T will change everytime we'll have passed L times in the algorithm loop, and will decrease at the alpha rate
        k = k+1
    end

    #choice to move or not to this new solution
    if (new_DC_indicator < current_DC_indicator)  #we accept the move since the new DC indicator is smaller
        current_weekly_sol = new_current_solution #the new current weekly schedules/routes become the neighor we have just found
        current_DC_indicator = new_DC_indicator #the new current optimal DC indicator becomes the one we have just found
        current_RB_indicator = new_RB_indicator #the new current RB indicator becomes the one we have just found in the solution having the optimal DC indicator
        push!(DC_indicators, current_DC_indicator)
        push!(weekly_sols, current_weekly_sol)
        push!(RB_indicators, current_RB_indicator)
        a = 1 #register that we accept the move for this iteration
        println("For our iteration $iteration, we decided to move to the new DC indicator $current_DC_indicator")
        cost_decrased_sols = cost_decrased_sols+1 #update the number of solutions we accepted with a decreasing indicator value

    else #the DC indicator has increased with the new solution but we've to check if we move or not
        u = rand() #random number between 0 and 1
        if u <= p #then we accept the move
            current_weekly_sol = new_current_solution #the new current weekly schedules/routes become the neighor we have just found
            current_DC_indicator = new_DC_indicator #the new current DC indicator becomes the one we have just found
            current_RB_indicator = new_RB_indicator #the new current RB indicator becomes the one we have just found
            cost_increased_sols = cost_increased_sols+1 #update the number of solutions we accepted with an increasing cost
            push!(DC_indicators, current_DC_indicator)
            push!(weekly_sols, current_weekly_sol)
            push!(RB_indicators, current_RB_indicator)
            a = 1 #register that we accept the move for this iteration
            println("For our iteration $iteration, we decided to move to the new DC indicator $current_DC_indicator even if the new DC indicator is bigger")
        else #we refuse the move
            a = 0 #register that we refuse the move for this iteration
            println("For our iteration $iteration, we decided not to move")
        end
    end

    #we check if we have to change the plateau and change it if it is the case
    iteration = iteration+1
    sub_iteration = sub_iteration+1
    if sub_iteration == L
        sub_iteration = 1
        T = alpha*T
        p = exp(-delta/T)
    end

    #we check if we have to look at the stopping conditions or not
    if iteration % (K*L) == 0  #if we are at a multiple of K*L iterations
        stopping_criteria = 1 #we have to look at the sopping conditions
        best_DC_now = findmin(DC_indicators)[1]
        if best_DC_now < best_DC_start
            best_DC_start = deepcopy(best_DC_now)
            improve = 1
        end
    else
        stopping_criteria = 0 #we don't have to look at the stopping conditions
    end

    #stopping conditions
    accepted_moves = cost_decrased_sols+cost_increased_sols #number of moves that we've done
    if stopping_criteria == 1 #if we have to look at the stopping conditions

        if (cost_decrased_sols == 0 && accepted_moves < epsilon*L) || improve == 0 #if the first stopping conditions are met
            global best_DC = findmin(DC_indicators) #we register the best solution found
            global best_DC_indicator1 = best_DC[1]
            index = best_DC[2]
            global best_solution = weekly_sols[index]
            global best_RB_indicator1 = RB_indicators[index]
            println("End of the algorithm. The last update of the solution has the DC indicator $current_DC_indicator")
            println("In all the algorithm, the best DC indicator found is $best_DC_indicator1 with the corresponding RB indicator $best_RB_indicator1")
            algorithm = 1 #we stop the algorithm
        elseif improve == 0 #if the second stopping conditions are met
            global best_DC = findmin(DC_indicators) #we register the best solution found
            global best_DC_indicator1 = best_DC[1]
            index = best_DC[2]
            global best_solution = weekly_sols[index]
            global best_RB_indicator1 = RB_indicators[index]
            println("End of the algorithm. The last update of the solution has the DC indicator $current_DC_indicator")
            println("In all the algorithm, the best DC indicator found is $best_DC_indicator1 with the corresponding RB indicator $best_RB_indicator1")
            algorithm = 1 #we stop the algorithm
        end
        cost_decrased_sols=0 #if the stopping conditions are not met, we put to 0 these counters and we continue
        cost_increased_sols=0
    end
end
t2 = time()
time1 = t2-t1
iteration1 = iteration
#=
#--------------------------------------------------------------SA FIRST ITERATION - RESULTS PRINT IN EXCEL-------------------------------------------------------------------------#
xfilename = "best_solution_instance_$instance-run$run-firstSA.xlsx"
xfilename2 = "best_solution_instance_$instance.indicators-run$run-firstSA.xlsx"
best_sol1 = DataFrame(Day = [], Driver = [], ID_stop=[],ID_loc=[],ID_cust=[], earliest_a=[], effective_a=[],latest_a=[],start_service=[],service_time=[],earliest_d=[],effective_d=[],latest_d=[],current_slack_time=[],load_A=[],load_B=[],load_C=[],ID_request=[], P_or_D=[])
indicators = DataFrame(DC_indicator = [], RB_indicator = [], iterations = [], time1 = [])

for ind in keys(best_solution.solutions)
    for inx in keys(best_solution.solutions[ind].routes)
        for loc in keys(best_solution.solutions[ind].routes[inx].localisations)
            day = ind
            driver = inx
            ID_stop = best_solution.solutions[ind].routes[inx].localisations[loc].ID_stop
            ID_loc = best_solution.solutions[ind].routes[inx].localisations[loc].ID_loc
            ID_cust = best_solution.solutions[ind].routes[inx].localisations[loc].ID_cust
            earliest_a = best_solution.solutions[ind].routes[inx].localisations[loc].earliest_a
            effective_a = best_solution.solutions[ind].routes[inx].localisations[loc].effective_a
            latest_a = best_solution.solutions[ind].routes[inx].localisations[loc].latest_a
            start_service = best_solution.solutions[ind].routes[inx].localisations[loc].start_service
            service_time = best_solution.solutions[ind].routes[inx].localisations[loc].service_time
            earliest_d = best_solution.solutions[ind].routes[inx].localisations[loc].earliest_d
            effective_d = best_solution.solutions[ind].routes[inx].localisations[loc].effective_d
            latest_d = best_solution.solutions[ind].routes[inx].localisations[loc].latest_d
            current_slack_time = best_solution.solutions[ind].routes[inx].localisations[loc].current_slack_time
            load_A = best_solution.solutions[ind].routes[inx].localisations[loc].load_A
            load_B = best_solution.solutions[ind].routes[inx].localisations[loc].load_B
            load_C = best_solution.solutions[ind].routes[inx].localisations[loc].load_C
            ID_request = best_solution.solutions[ind].routes[inx].localisations[loc].ID_request
            P_or_D = best_solution.solutions[ind].routes[inx].localisations[loc].P_or_D
            push!(best_sol1, [day, driver, ID_stop, ID_loc, ID_cust, earliest_a, effective_a, latest_a, start_service, service_time, earliest_d, effective_d,latest_d,current_slack_time,load_A,load_B,load_C,ID_request,P_or_D])
        end
    end
end
iteration1 = iteration
push!(indicators, [best_DC_indicator1, best_RB_indicator1, iteration1, time1])
XLSX.writetable(xfilename, Best_Sol_DC1_RB2_1=(collect(DataFrames.eachcol(best_sol1)), DataFrames.names(best_sol1)))
XLSX.writetable(xfilename2, Best_Sol_DC1_RB2_1_Indicators=(collect(DataFrames.eachcol(indicators)), DataFrames.names(indicators)))
=#
#-----------------------------------------------------SIMULATED ANNEALING - LOWER-LEVEL OBJECTIVE (route balancing)--------------------------------------------------------------#
#Vectors that will allow us to find the best solution:
RB_indicators = [] #vector that will contain all the DC indicators that we'll find
weekly_sols2 = [] #vector that will contain all the weekly routes/schedules that we'll find
DC_indicators = []
#Counters initialization
k = 1 #1 for the first neighbor, 0 after (allow to define T(0) regarding p(0))
current_weekly_sol = best_solution
DC_LIMIT = best_DC_indicator1 #the level of DCI obtained with the first SA iteration cannot be degraded in this second SA iteration
current_DC_indicator = best_DC_indicator1 #the algorithm starts with the best solution found in the first SA iteration
current_RB_indicator = best_RB_indicator1
push!(RB_indicators, current_RB_indicator)
push!(weekly_sols2, current_weekly_sol)
push!(DC_indicators, current_DC_indicator)
iteration = 1 #will count the total number of iterations
sub_iteration = 1 #will count the number of iterations until L, in order to know when we have to change of plateau (so become 0 after L iterations)
cost_decrased_sols = 0 #will count the number of solutions that we'll accept because they allow to decrease the cost, until we've to look at the stopping conditions (so become 0 after K*L iterations)
cost_increased_sols = 0 #will count the number of solutions that we'll accept even if they increase the cost, until we've to look at the stopping conditions (so become 0 after K*L iterations)
stopping_criteria = 0 #will count the number of iterations in order to know if we have to look at the stopping conditions (so become 0 after K*L iterations)
algorithm = 0 #define if we continue to run the algorithm; 0 if yes, 1 otherwise
best_RB_start = 1000

#Start of the algorithm loop
t3 = time()
while algorithm < 1 #as long as we have to continue to run the algorithm...
    #creation of a neighbor starting from our current solution, using the neighborhood structure focusing on route balancing
    neighbor = neighbor_fairness(current_weekly_sols,weekly_requests,times_matrix,cap_vehicles,max_route_duration,Nb_drivers,Nb_cust)
    new_current_solution = neighbor[1]
    new_DC_indicator = neighbor[2]
    new_RB_indicator = neighbor[3]
    improve = 0

    #comparison of the new obtained solution with the previous one
    println("The initial RB indicator from the precedent solution was $current_RB_indicator")
    println("The new RB indicator from this neighbor is $new_RB_indicator")

    delta = abs(new_RB_indicator - current_RB_indicator) #computation of delta

    if k == 1 #computation of T(0) thanks to p(0), works only for the first iteration
        T = -(delta/log(p))  #our T will change everytime we'll have passed L times in the algorithm loop, and will decrease at the alpha rate
        k = k+1
    end

    #choice to move or not to this new solution
    if new_RB_indicator < current_RB_indicator && new_DC_indicator <= DC_LIMIT #we accept the move since the new RB indicator is smaller AND the new DC indicator is smaller or equal of the DCI obtained during the first SA iteration
        current_weekly_sol = new_current_solution #the new current weekly schedules/routes become the neighor we have just found
        current_RB_indicator = new_RB_indicator #the new current optimal RB indicator becomes the one we have just found
        current_DC_indicator = new_DC_indicator
        push!(RB_indicators, current_RB_indicator)
        push!(weekly_sols2, current_weekly_sol)
        push!(DC_indicators, current_DC_indicator)
        a = 1 #register that we accept the move for this iteration
        println("For our iteration $iteration, we decided to move to the new RB indicator $current_RB_indicator")
        cost_decrased_sols = cost_decrased_sols+1 #update the number of solutions we accepted with a decreasing cost

    else #the RB  indicator has increased with the new solution but we've to check if we move or not
        u = rand() #random number between 0 and 1
        if u <= p && new_DC_indicator <= DC_LIMIT #then we accept the move
            current_weekly_sol = new_current_solution #the new current weekly schedules/routes become the neighor we have just found
            current_RB_indicator = new_RB_indicator #the new current optimal RB indicator becomes the one we have just found
            current_DC_indicator = new_DC_indicator
            cost_increased_sols = cost_increased_sols+1 #update the number of solutions we accepted with an increasing cost
            push!(RB_indicators, current_RB_indicator)
            push!(weekly_sols2, current_weekly_sol)
            push!(DC_indicators, current_DC_indicator)
            a = 1 #register that we accept the move for this iteration
            println("For our iteration $iteration, we decided to move to the new RB indicator $current_RB_indicator even if the new RB indicator is bigger")
        else #we refuse the move
            a = 0 #register that we refuse the move for this iteration
            println("For our iteration $iteration, we decided not to move")
        end
    end

    #we check if we have to change the plateau and change it if it is the case
    iteration = iteration+1
    sub_iteration = sub_iteration+1
    if sub_iteration == L
        sub_iteration = 1
        global T = alpha*T
        p = exp(-delta/T)
    end

    #we check if we have to look at the stopping conditions or not
    if iteration % (K*L) == 0  #if we are at a multiple of K*L iterations
        stopping_criteria = 1 #we have to look at the sopping conditions
        best_RB_now = findmin(RB_indicators)[1]
        if best_RB_now < best_RB_start
            best_RB_start = deepcopy(best_RB_now)
            improve = 1
        end
    else
        stopping_criteria = 0 #we don't have to look at the stopping conditions
    end

    #stopping conditions
    accepted_moves = cost_decrased_sols+cost_increased_sols #number of moves that we've done
    if stopping_criteria == 1 #if we have to look at the stopping conditions
        if (cost_decrased_sols == 0 && accepted_moves < epsilon*L) #if the first stopping conditions are met
            global best_RB = findmin(RB_indicators) #we register the best solution found
            global best_RB_indicator2 = best_RB[1]
            global best_solution2 = weekly_sols2[best_RB[2]]
            global best_DC_indicator2 = DC_indicators[best_RB[2]]
            println("End of the algorithm. The last update of the solution has the RB indicator $current_RB_indicator")
            println("In all the algorithm, the best RB indicator found is $best_RB_indicator2 and the DC indicator $best_DC_indicator2")
            algorithm = 1 #we stop the algorithm
        elseif improve == 0 #if the second stopping conditions are met
            global best_RB = findmin(RB_indicators) #we register the best solution found
            global best_RB_indicator2 = best_RB[1]
            global best_solution2 = weekly_sols2[best_RB[2]]
            global best_DC_indicator2 = DC_indicators[best_RB[2]]
            println("End of the algorithm. The last update of the solution has the RB indicator $current_RB_indicator")
            println("In all the algorithm, the best RB indicator found is $best_RB_indicator2 and the DC indicator $best_DC_indicator2")
            algorithm = 1 #we stop the algorithm
        end
        cost_decrased_sols=0 #if the stopping conditions are not met, we put to 0 these counters and we continue
        cost_increased_sols=0
    end
end
t4 = time()
time2 = t4-t3
total_time = time1+time2 #total time taken by the two SA iterations to obtain the best solution found

#--------------------------------------------------------------SECOND SA - RESULTS PRINT IN EXCEL-------------------------------------------------------------------------#
xfilename3 = "best_solution_instance_$instance.routes-run$run.xlsx"
xfilename4 = "best_solution_instance_$instance.indicators-run$run.xlsx"
best_sol2 = DataFrame(Day = [], Driver = [], ID_stop=[],ID_loc=[],ID_cust=[], earliest_a=[], effective_a=[],latest_a=[],start_service=[],service_time=[],earliest_d=[],effective_d=[],latest_d=[],current_slack_time=[],load_A=[],load_B=[],load_C=[],ID_request=[], P_or_D=[])
indicators2 = DataFrame(DC_indicator = [], RB_indicator = [], iterations = [], time2 = [], total_time = [])

for ind in keys(best_solution2.solutions)
    for inx in keys(best_solution2.solutions[ind].routes)
        for loc in keys(best_solution2.solutions[ind].routes[inx].localisations)
            day = ind
            driver = inx
            ID_stop = best_solution2.solutions[ind].routes[inx].localisations[loc].ID_stop
            ID_loc = best_solution2.solutions[ind].routes[inx].localisations[loc].ID_loc
            ID_cust = best_solution2.solutions[ind].routes[inx].localisations[loc].ID_cust
            earliest_a = best_solution2.solutions[ind].routes[inx].localisations[loc].earliest_a
            effective_a = best_solution2.solutions[ind].routes[inx].localisations[loc].effective_a
            latest_a = best_solution2.solutions[ind].routes[inx].localisations[loc].latest_a
            start_service = best_solution2.solutions[ind].routes[inx].localisations[loc].start_service
            service_time = best_solution2.solutions[ind].routes[inx].localisations[loc].service_time
            earliest_d = best_solution2.solutions[ind].routes[inx].localisations[loc].earliest_d
            effective_d = best_solution2.solutions[ind].routes[inx].localisations[loc].effective_d
            latest_d = best_solution2.solutions[ind].routes[inx].localisations[loc].latest_d
            current_slack_time = best_solution2.solutions[ind].routes[inx].localisations[loc].current_slack_time
            load_A = best_solution2.solutions[ind].routes[inx].localisations[loc].load_A
            load_B = best_solution2.solutions[ind].routes[inx].localisations[loc].load_B
            load_C = best_solution2.solutions[ind].routes[inx].localisations[loc].load_C
            ID_request = best_solution2.solutions[ind].routes[inx].localisations[loc].ID_request
            P_or_D = best_solution2.solutions[ind].routes[inx].localisations[loc].P_or_D
            push!(best_sol2, [day, driver, ID_stop, ID_loc, ID_cust, earliest_a, effective_a, latest_a, start_service, service_time, earliest_d, effective_d,latest_d,current_slack_time,load_A,load_B,load_C,ID_request,P_or_D])
        end
    end
end
iteration2 = iteration
iteration3 = iteration1 + iteration2
push!(indicators2, [best_DC_indicator2, best_RB_indicator2, iteration3, time2, total_time])
XLSX.writetable(xfilename3, Best_Sol_DC1_RB2_2=(collect(DataFrames.eachcol(best_sol2)), DataFrames.names(best_sol2)))
XLSX.writetable(xfilename4, Best_Sol_DC1_RB2_2_Indicators=(collect(DataFrames.eachcol(indicators2)), DataFrames.names(indicators2)))
end
ions[loc].ID_cust
            earliest_a = best_solution2.solutions[ind].routes[inx].localisations[loc].earliest_a
            effective_a = best_solution2.solutions[ind].routes[inx].localisations[loc].effective_a
            latest_a = best_solution2.solutions[ind].routes[inx].localisations[loc].latest_a
            start_service = best_solution2.solutions[ind].routes[inx].localisations[loc].start_service
            service_time = best_solution2.solutions[ind].routes[inx].localisations[loc].service_time
            earliest_d = best_solution2.solutions[ind].routes[inx].localisations[loc].earliest_d
            effective_d = best_solutio